> ## Documentation Index
> Fetch the complete documentation index at: https://docs.li.fi/llms.txt
> Use this file to discover all available pages before exploring further.

# Get a set of routes for a request that describes a transfer of tokens

> In order to execute any transfer, you must first request possible `Routes`. From the result set a `Route` can be selected and executed by retrieving the transaction for every included `Step` using the `/steps/transaction` endpoint.
**Attention**: This request is more complex and intended to be used via our [JavaScript SDK](https://docs.li.fi/integrate-li.fi-js-sdk/install-li.fi-sdk).

<Info>
  Need opinionated routing defaults? Include `options.preset` in the request body and review the
  [API presets overview](/api-reference/presets/overview) for the supported configurations.
</Info>


## OpenAPI

````yaml post /v1/advanced/routes
openapi: 3.0.2
info:
  title: LI.FI API
  version: 1.0.0
  description: >-
    LI.FI provides the best cross-chain swap across all liquidity pools and
    bridges.
servers:
  - url: https://li.quest
    description: LI.FI Production Environment
  - url: https://staging.li.quest
    description: LI.FI Staging Environment
security: []
paths:
  /v1/advanced/routes:
    post:
      tags:
        - advanced
      summary: Get a set of routes for a request that describes a transfer of tokens
      description: >-
        In order to execute any transfer, you must first request possible
        `Routes`. From the result set a `Route` can be selected and executed by
        retrieving the transaction for every included `Step` using the
        `/steps/transaction` endpoint.

        **Attention**: This request is more complex and intended to be used via
        our [JavaScript
        SDK](https://docs.li.fi/integrate-li.fi-js-sdk/install-li.fi-sdk).
      parameters:
        - name: x-lifi-api-key
          description: >-
            Authentication header, register in the LI.FI Partner Portal
            (https://portal.li.fi/ ) to get your API Key.
          schema:
            type: string
          in: header
      requestBody:
        description: >-
          The request object describes a desired any-to-any transfer and
          contains all information necessary to calculate the most efficient
          routes.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RoutesRequest'
            examples:
              RoutesRequestExample:
                value:
                  fromChainId: 100
                  fromAmount: '1000000000000000000'
                  fromTokenAddress: '0x0000000000000000000000000000000000000000'
                  toChainId: 137
                  toTokenAddress: '0x0000000000000000000000000000000000000000'
                  options:
                    integrator: fee-demo
                    referrer: '0x552008c0f6870c2f77e5cC1d2eb9bdff03e30Ea0'
                    slippage: 0.003
                    fee: 0.02
                    bridges:
                      allow:
                        - relay
                    exchanges:
                      allow:
                        - 1inch
                        - openocean
                    allowSwitchChain: true
                    order: CHEAPEST
                    maxPriceImpact: 0.1
        required: true
      responses:
        '200':
          $ref: '#/components/responses/RoutesResponse'
        '400':
          $ref: '#/components/responses/InvalidRoutesRequest'
        '404':
          $ref: '#/components/responses/InvalidRoutesNotFoundRequest'
components:
  schemas:
    RoutesRequest:
      title: Root Type for RoutesRequest
      description: A description of a token transfer
      required:
        - fromAmount
        - fromChainId
        - fromTokenAddress
        - toChainId
        - toTokenAddress
      type: object
      properties:
        fromChainId:
          format: number
          description: The sending chain id
          type: number
        fromAmount:
          description: >-
            The amount that should be transferred including all decimals (e.g.
            1000000 for 1 USDC (6 decimals))
          type: string
        fromTokenAddress:
          description: The address of the sending `Token`
          type: string
        toChainId:
          format: number
          description: The id of the receiving chain
          type: number
        toTokenAddress:
          description: The address of the receiving `Token`
          type: string
        options:
          $ref: '#/components/schemas/RouteOptions'
          description: Optional configuration for the routes
        fromAddress:
          description: The sending wallet address
          type: string
        toAddress:
          description: The receiving wallet address
          type: string
        fromAmountForGas:
          description: The amount of the token to convert to gas on the destination side.
          type: string
      example:
        fromAddress: '0x552008c0f6870c2f77e5cC1d2eb9bdff03e30Ea0'
        fromChainId: 100
        fromAmount: '1000000000000000000'
        fromTokenAddress: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
        toChainId: 137
        toTokenAddress: '0xc0b2983a17573660053beeed6fdb1053107cf387'
        options:
          integrator: fee-demo
          slippage: 0.003
          fee: 0.02
          bridges:
            allow:
              - relay
          exchanges:
            allow:
              - 1inch
              - openocean
    RouteOptions:
      title: Root Type for RouteOptions
      description: Optional settings for the route
      type: object
      properties:
        insurance:
          deprecated: true
          description: >-
            Facilitates transfer insurance via insurace.io, ensuring secure and
            insured transfer of assets.
          type: boolean
        integrator:
          description: Custom string the developer who integrates LiFi can set
          type: string
        slippage:
          format: double
          description: The maximum allowed slippage
          type: number
        bridges:
          $ref: '#/components/schemas/AllowDenyPrefer'
          description: >-
            Object configuring the bridges that should or should not be taken
            into consideration for the possibilities
          properties:
            allow:
              default:
                - all
              type: array
              items:
                type: string
            deny:
              type: array
              items:
                type: string
            prefer:
              type: array
              items:
                type: string
        exchanges:
          $ref: '#/components/schemas/AllowDenyPrefer'
          description: >-
            Object configuring the exchanges that should or should not be taken
            into consideration for the possibilities
          properties:
            allow:
              default:
                - all
              type: array
              items:
                type: string
            deny:
              type: array
              items:
                type: string
            prefer:
              type: array
              items:
                type: string
        order:
          description: The way the resulting routes should be ordered
          enum:
            - FASTEST
            - CHEAPEST
          type: string
        allowSwitchChain:
          description: Whether chain switches should be allowed in the routes
          default: false
          type: boolean
        allowDestinationCall:
          description: >-
            Defines if we should return routes with a cross-chain bridge
            protocol (Connext, etc.) destination calls or not.
          default: true
          type: boolean
        referrer:
          description: Integrators can set a wallet address as referrer to track them
          type: string
        fee:
          format: double
          description: >-
            The percent of the integrator's fee that is taken from every
            transaction. The maximum fee amount should be less than 100%.
          maximum: 1
          exclusiveMaximum: true
          minimum: 0
          type: number
        maxPriceImpact:
          format: double
          description: >-
            The price impact threshold above which routes are hidden. As an
            example, one should specify 0.15 (15%) to hide routes with more than
            15% price impact. The default is 10%.
          type: number
        timing:
          type: object
          properties:
            swapStepTimingStrategies:
              description: >-
                Timing setting to wait for a certain amount of swap rates.
                Please check [docs.li.fi](https://docs.li.fi) for more details.
              type: array
              items:
                type: object
                properties:
                  strategy:
                    enum:
                      - minWaitTime
                  minWaitTimeMs:
                    maximum: 15000
                    minimum: 0
                    type: number
                  startingExpectedResults:
                    type: number
                    minimum: 0
                    maximum: 100
                  reduceEveryMs:
                    maximum: 15000
                    minimum: 0
                    type: number
            routeTimingStrategies:
              description: >-
                Timing setting to wait for a certain amount of routes to be
                generated before choosing the best one. Please check
                [docs.li.fi](https://docs.li.fi) for more details.
              type: array
              items:
                type: object
                properties:
                  strategy:
                    enum:
                      - minWaitTime
                  minWaitTimeMs:
                    maximum: 15000
                    minimum: 0
                    type: number
                  startingExpectedResults:
                    type: number
                    minimum: 0
                    maximum: 100
                  reduceEveryMs:
                    maximum: 15000
                    minimum: 0
                    type: number
        preset:
          description: >-
            Pre-configured routing and quote optimization preset. The preset
            value `stablecoin` is supported for requesting swap and/or bridging
            operations involving stablecoin tokens. Each preset provides
            optimized default settings for slippage, price impact, and tool
            preferences that can be overridden by custom configuration options
            specified in the same request.
          type: string
          pattern: ^[a-zA-Z0-9-_]+$
          minLength: 1
          maxLength: 50
          example: stablecoin
        svmPriorityFeeLevel:
          description: Priority fee level for Solana Virtual Machine (SVM) transactions.
          enum:
            - NORMAL
            - FAST
            - ULTRA
          type: string
      example:
        integrator: fee-demo
        slippage: 0.003
        fee: 0.02
        bridges:
          allow:
            - relay
        exchanges:
          allow:
            - 1inch
            - openocean
        maxPriceImpact: 0.1
    RoutesResponse:
      title: Root Type for RoutesResponse
      description: >-
        A list of routes that can be used to realize the described transfer of
        tokens
      required:
        - routes
      type: object
      properties:
        routes:
          description: List of possible `Routes` for the given transfer
          type: array
          items:
            $ref: '#/components/schemas/Route'
        unavailableRoutes:
          description: >-
            An object representing the routes that are unavailable for the given
            transfer
          type: array
          items:
            $ref: '#/components/schemas/UnavailableRoutes'
      example:
        routes:
          - id: '0x1e21fad9c26fff48b67ae2925f878e43bf81211da8b1cd9b7faa8bfd8d7ea9d9'
            fromChainId: 100
            fromAmountUSD: '0.05'
            fromAmount: '1000000000000000000'
            fromToken:
              address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
              symbol: MIVA
              decimals: 18
              chainId: 100
              name: Minerva Wallet SuperToken
              coinKey: MIVA
              priceUSD: '0.04547537276751318'
              logoURI: ''
            toChainId: 137
            toAmountUSD: '0.00'
            toAmount: '999500000000000000'
            toAmountMin: '999500000000000000'
            toToken:
              address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
              symbol: MIVA
              decimals: 18
              chainId: 137
              name: Minerva Wallet SuperToken
              coinKey: MIVA
              priceUSD: '0'
              logoURI: ''
            gasCostUSD: '0.00'
            steps:
              - id: >-
                  0x48f0a2f93b0d0a9dab992d07c46bca38516c945101e8f8e08ca42af05b9e6aa9
                type: cross
                tool: relay
                action:
                  fromChainId: 100
                  toChainId: 137
                  fromToken:
                    address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                    symbol: MIVA
                    decimals: 18
                    chainId: 100
                    name: Minerva Wallet SuperToken
                    coinKey: MIVA
                    priceUSD: '0.04547537276751318'
                    logoURI: ''
                  toToken:
                    address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                    symbol: MIVA
                    decimals: 18
                    chainId: 137
                    name: Minerva Wallet SuperToken
                    coinKey: MIVA
                    priceUSD: '0'
                    logoURI: ''
                  fromAmount: '1000000000000000000'
                  slippage: 0.003
                estimate:
                  fromAmount: '1000000000000000000'
                  toAmount: '999500000000000000'
                  toAmountMin: '999500000000000000'
                  approvalAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
                  feeCosts:
                    - name: Gas Fee
                      description: >-
                        Covers gas expense for sending funds to user on
                        receiving chain.
                      percentage: '0'
                      token:
                        address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                        symbol: MIVA
                        decimals: 18
                        chainId: 100
                        name: Minerva Wallet SuperToken
                        coinKey: MIVA
                        priceUSD: '0.04547537276751318'
                        logoURI: ''
                      amount: '0'
                      amountUSD: '0.00'
                      included: true
                    - name: Relay Fee
                      description: >-
                        Covers gas expense for claiming user funds on receiving
                        chain.
                      percentage: '0'
                      token:
                        address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                        symbol: MIVA
                        decimals: 18
                        chainId: 100
                        name: Minerva Wallet SuperToken
                        coinKey: MIVA
                        priceUSD: '0.04547537276751318'
                        logoURI: ''
                      amount: '0'
                      amountUSD: '0.00'
                    - name: Router Fee
                      description: Router service fee.
                      percentage: '0.0005'
                      token:
                        address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                        symbol: MIVA
                        decimals: 18
                        chainId: 100
                        name: Minerva Wallet SuperToken
                        coinKey: MIVA
                        priceUSD: '0.04547537276751318'
                        logoURI: ''
                      amount: '500000000000000'
                      amountUSD: '22737686383756.59'
                  gasCosts:
                    - type: SEND
                      price: '1.26'
                      estimate: '140000'
                      limit: '175000'
                      amount: '176400'
                      amountUSD: '0.00'
                      token:
                        address: '0x0000000000000000000000000000000000000000'
                        symbol: xDai
                        decimals: 18
                        chainId: 100
                        name: xDai
                        coinKey: xDai
                        priceUSD: '1'
                        logoURI: >-
                          https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
                  data:
                    bid:
                      user: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                      router: '0xeE2Ef40F688607CB23618d9312d62392786d13EB'
                      initiator: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                      sendingChainId: 100
                      sendingAssetId: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                      amount: '1000000000000000000'
                      receivingChainId: 137
                      receivingAssetId: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                      amountReceived: '999500000000000000'
                      receivingAddress: '0x10fBFF9b9450D3A2d9d1612d6dE3726fACD8809E'
                      transactionId: >-
                        0x48f0a2f93b0d0a9dab992d07c46bca38516c945101e8f8e08ca42af05b9e6aa9
                      expiry: 1643364189
                      callDataHash: >-
                        0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470
                      callTo: '0x0000000000000000000000000000000000000000'
                      encryptedCallData: 0x
                      sendingChainTxManagerAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
                      receivingChainTxManagerAddress: '0x6090De2EC76eb1Dc3B5d632734415c93c44Fd113'
                      bidExpiry: 1643105290
                    gasFeeInReceivingToken: '0'
                    totalFee: '500000000000000'
                    metaTxRelayerFee: '0'
                    routerFee: '500000000000000'
                integrator: fee-demo
          - id: '0xb785f52e68f8a6fb147d5e392e06f122c1a418be84bdc28de0f311b91fa5e57e'
            fromChainId: 100
            fromAmountUSD: '0.05'
            fromAmount: '1000000000000000000'
            fromToken:
              address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
              symbol: MIVA
              decimals: 18
              chainId: 100
              name: Minerva Wallet SuperToken
              coinKey: MIVA
              priceUSD: '0.04547537276751318'
              logoURI: ''
            toChainId: 137
            toAmountUSD: '0.00'
            toAmount: '941511949935063841'
            toAmountMin: '913266591437011926'
            toToken:
              address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
              symbol: MIVA
              decimals: 18
              chainId: 137
              name: Minerva Wallet SuperToken
              coinKey: MIVA
              priceUSD: '0'
              logoURI: ''
            gasCostUSD: '0.10'
            steps:
              - id: ea5abad4-2e2a-476f-981d-797816e5cc77
                type: swap
                tool: 1inch
                action:
                  fromChainId: 100
                  toChainId: 100
                  fromToken:
                    address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                    symbol: MIVA
                    decimals: 18
                    chainId: 100
                    name: Minerva Wallet SuperToken
                    coinKey: MIVA
                    priceUSD: '0.04547537276751318'
                    logoURI: ''
                  toToken:
                    name: Own a fraction
                    symbol: FRACTION
                    coinKey: FRACTION
                    decimals: 18
                    chainId: 100
                    logoURI: >-
                      https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                    address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                  fromAmount: '1000000000000000000'
                  slippage: 0.003
                estimate:
                  fromAmount: '1000000000000000000'
                  toAmount: '809146346742'
                  toAmountMin: '784871956340'
                  approvalAddress: '0x1111111254fb6c44bac0bed2854e76f90643097d'
                  feeCosts: []
                  gasCosts:
                    - type: SEND
                      price: '1.26'
                      estimate: '252364'
                      limit: '315455'
                      amount: '317979'
                      amountUSD: '0.00'
                      token:
                        address: '0x0000000000000000000000000000000000000000'
                        symbol: xDai
                        decimals: 18
                        chainId: 100
                        name: xDai
                        coinKey: xDai
                        priceUSD: '1'
                        logoURI: >-
                          https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
                  data:
                    fromToken:
                      name: Minerva Wallet SuperToken
                      address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                      symbol: MIVA
                      decimals: 18
                      logoURI: https://minerva.digital/i/MIVA-Token_200x200.png
                    toToken:
                      address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                      decimals: 18
                      symbol: FRACTION
                      name: Own a fraction
                      logoURI: https://etherscan.io/images/main/empty-token.png
                      isCustom: true
                    toTokenAmount: '809146346742'
                    fromTokenAmount: '1000000000000000000'
                    protocols:
                      - - - name: GNOSIS_HONEYSWAP
                            part: 100
                            fromTokenAddress: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                            toTokenAddress: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                    estimatedGas: 252364
                integrator: fee-demo
              - id: >-
                  0x85e93238e8f2f83dd5840eb748c7b9099d69e1ea227a13e7a2e949cf6a32ab7d
                type: cross
                tool: relay
                action:
                  fromChainId: 100
                  toChainId: 137
                  fromToken:
                    name: Own a fraction
                    symbol: FRACTION
                    coinKey: FRACTION
                    decimals: 18
                    chainId: 100
                    logoURI: >-
                      https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                    address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                  toToken:
                    name: Own a fraction
                    symbol: FRACTION
                    coinKey: FRACTION
                    decimals: 18
                    chainId: 137
                    logoURI: >-
                      https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                    address: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                  fromAmount: '784871956340'
                  slippage: 0.003
                estimate:
                  fromAmount: '784871956340'
                  toAmount: '784479520361'
                  toAmountMin: '784479520361'
                  approvalAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
                  feeCosts:
                    - name: Gas Fee
                      description: >-
                        Covers gas expense for sending funds to user on
                        receiving chain.
                      percentage: '0'
                      token:
                        name: Own a fraction
                        symbol: FRACTION
                        coinKey: FRACTION
                        decimals: 18
                        chainId: 100
                        logoURI: >-
                          https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                        address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                      amount: '0'
                      amountUSD: '0.00'
                      included: true
                    - name: Relay Fee
                      description: >-
                        Covers gas expense for claiming user funds on receiving
                        chain.
                      percentage: '0'
                      token:
                        name: Own a fraction
                        symbol: FRACTION
                        coinKey: FRACTION
                        decimals: 18
                        chainId: 100
                        logoURI: >-
                          https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                        address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                      amount: '0'
                      amountUSD: '0.00'
                      included: true
                    - name: Router Fee
                      description: Router service fee.
                      percentage: '0.00050000000105749733'
                      token:
                        name: Own a fraction
                        symbol: FRACTION
                        coinKey: FRACTION
                        decimals: 18
                        chainId: 100
                        logoURI: >-
                          https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                        address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                      amount: '392435979'
                      amountUSD: '0.00'
                      included: true
                  gasCosts:
                    - type: SEND
                      price: '1.26'
                      estimate: '140000'
                      limit: '175000'
                      amount: '176400'
                      amountUSD: '0.00'
                      token:
                        address: '0x0000000000000000000000000000000000000000'
                        symbol: xDai
                        decimals: 18
                        chainId: 100
                        name: xDai
                        coinKey: xDai
                        priceUSD: '1'
                        logoURI: >-
                          https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
                  data:
                    bid:
                      user: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                      router: '0xeE2Ef40F688607CB23618d9312d62392786d13EB'
                      initiator: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                      sendingChainId: 100
                      sendingAssetId: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                      amount: '784871956340'
                      receivingChainId: 137
                      receivingAssetId: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                      amountReceived: '784479520361'
                      receivingAddress: '0x10fBFF9b9450D3A2d9d1612d6dE3726fACD8809E'
                      transactionId: >-
                        0x85e93238e8f2f83dd5840eb748c7b9099d69e1ea227a13e7a2e949cf6a32ab7d
                      expiry: 1643364189
                      callDataHash: >-
                        0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470
                      callTo: '0x0000000000000000000000000000000000000000'
                      encryptedCallData: 0x
                      sendingChainTxManagerAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
                      receivingChainTxManagerAddress: '0x6090De2EC76eb1Dc3B5d632734415c93c44Fd113'
                      bidExpiry: 1643105290
                    gasFeeInReceivingToken: '0'
                    totalFee: '392435979'
                    metaTxRelayerFee: '0'
                    routerFee: '392435979'
                integrator: fee-demo
              - id: d8686af1-c131-4566-bf4a-ef8226f9879b
                type: swap
                tool: 1inch
                action:
                  fromChainId: 137
                  toChainId: 137
                  fromToken:
                    name: Own a fraction
                    symbol: FRACTION
                    coinKey: FRACTION
                    decimals: 18
                    chainId: 137
                    logoURI: >-
                      https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                    address: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                  toToken:
                    address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                    symbol: MIVA
                    decimals: 18
                    chainId: 137
                    name: Minerva Wallet SuperToken
                    coinKey: MIVA
                    priceUSD: '0'
                    logoURI: ''
                  fromAmount: '784479520361'
                  slippage: 0.003
                estimate:
                  fromAmount: '784479520361'
                  toAmount: '941511949935063841'
                  toAmountMin: '913266591437011926'
                  approvalAddress: '0x1111111254fb6c44bac0bed2854e76f90643097d'
                  feeCosts: []
                  gasCosts:
                    - type: SEND
                      price: '129'
                      estimate: '549386'
                      limit: '686733'
                      amount: '70870794'
                      amountUSD: '0.10'
                      token:
                        address: '0x0000000000000000000000000000000000000000'
                        symbol: MATIC
                        decimals: 18
                        chainId: 137
                        name: MATIC
                        coinKey: MATIC
                        priceUSD: '1.469213'
                        logoURI: >-
                          https://static.debank.com/image/matic_token/logo_url/matic/e5a8a2860ba5cf740a474dcab796dc63.png
                  data:
                    fromToken:
                      address: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                      decimals: 18
                      symbol: FRACTION
                      name: Own a fraction
                      logoURI: https://etherscan.io/images/main/empty-token.png
                      isCustom: true
                    toToken:
                      address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                      decimals: 18
                      symbol: MIVA
                      name: Minerva Wallet SuperToken
                      logoURI: https://etherscan.io/images/main/empty-token.png
                      isCustom: true
                    toTokenAmount: '941511949935063841'
                    fromTokenAmount: '784479520361'
                    protocols:
                      - - - name: POLYGON_QUICKSWAP
                            part: 100
                            fromTokenAddress: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                            toTokenAddress: '0x7ceb23fd6bc0add59e62ac25578270cff1b9f619'
                        - - name: POLYDEX_FINANCE
                            part: 100
                            fromTokenAddress: '0x7ceb23fd6bc0add59e62ac25578270cff1b9f619'
                            toTokenAddress: '0xeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee'
                        - - name: POLYGON_QUICKSWAP
                            part: 100
                            fromTokenAddress: '0xeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee'
                            toTokenAddress: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                    estimatedGas: 549386
                integrator: fee-demo
        errors:
          - errorType: NO_QUOTE
            code: NO_POSSIBLE_ROUTE
            action:
              fromChainId: 42161
              toChainId: 42161
              fromToken:
                address: '0xff970a61a04b1ca14834a43f5de4533ebddb5cc8'
                decimals: 6
                symbol: USDC
                coinKey: USDC
                chainId: 42161
                name: USDC
                logoURI: >-
                  http://raw.githubusercontent.com/trustwallet/assets/master/blockchains/ethereum/assets/0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48/logo.png",
                priceUSD: '1.001'
              toToken:
                address: '0xfd086bc7cd5c481dcc9c85ebe478a1c0b69fcbb9'
                decimals: 6
                symbol: USDT
                coinKey: USDT
                chainId: 42161
                name: Tether USD
                logoURI: http://get.celer.app/cbridge-icons/USDT.png"
              fromAmount: '100000'
              slippage: 0.003
    AllowDenyPrefer:
      title: Root Type for AllowDenyPrefer
      description: Object defining which tools should be allowed, denied and preferred
      type: object
      properties:
        allow:
          description: Allowed tools
          type: array
          items:
            type: string
        deny:
          description: Forbidden tools
          type: array
          items:
            type: string
        prefer:
          description: Preferred tools
          type: array
          items:
            type: string
    Route:
      title: Root Type for Route
      description: A route describing a transfer form a token to another
      required:
        - fromAmount
        - fromAmountUSD
        - fromChainId
        - fromToken
        - id
        - steps
        - toAmount
        - toAmountMin
        - toAmountUSD
        - toChainId
        - toToken
      type: object
      properties:
        id:
          description: Unique identifier of the route
          type: string
        fromChainId:
          format: number
          description: The id of the sending chain
          type: number
        fromAmountUSD:
          description: The amount that should be transferred in USD
          type: string
        fromAmount:
          description: The amount that should be transferred
          type: string
        fromToken:
          $ref: '#/components/schemas/Token'
          description: The sending `Token`
        toChainId:
          format: number
          description: The id of the receiving chain
          type: number
        toAmountUSD:
          description: >-
            The estimated resulting amount of the `toToken` in USD as float with
            two decimals
          type: string
        toAmount:
          description: >-
            The estimated resulting amount of the `toToken` including all
            decimals
          type: string
        toAmountMin:
          description: The minimal resulting amount of the `toToken` including all decimals
          type: string
        toToken:
          $ref: '#/components/schemas/Token'
          description: The `Token` that should be transferred to
        gasCostUSD:
          description: Aggregation of th eunderlying gas costs in USD
          type: string
        steps:
          description: The steps required to fulfill the transfer
          type: array
          items:
            $ref: '#/components/schemas/Step'
        fromAddress:
          description: The sending wallet address
          type: string
        toAddress:
          description: The receiving wallet address
          type: string
        containsSwitchChain:
          description: Whether a chain switch is part of the route
          type: boolean
      example:
        id: '0x1e21fad9c26fff48b67ae2925f878e43bf81211da8b1cd9b7faa8bfd8d7ea9d9'
        fromChainId: 100
        fromAmountUSD: '0.05'
        fromAmount: '1000000000000000000'
        fromToken:
          address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
          symbol: MIVA
          decimals: 18
          chainId: 100
          name: Minerva Wallet SuperToken
          coinKey: MIVA
          priceUSD: '0.04547537276751318'
          logoURI: ''
        toChainId: 137
        toAmountUSD: '0.00'
        toAmount: '999500000000000000'
        toAmountMin: '999500000000000000'
        toToken:
          address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
          symbol: MIVA
          decimals: 18
          chainId: 137
          name: Minerva Wallet SuperToken
          coinKey: MIVA
          priceUSD: '0'
          logoURI: ''
        gasCostUSD: '0.00'
        steps:
          - id: '0x48f0a2f93b0d0a9dab992d07c46bca38516c945101e8f8e08ca42af05b9e6aa9'
            type: cross
            tool: relay
            action:
              fromChainId: 100
              toChainId: 137
              fromToken:
                address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                symbol: MIVA
                decimals: 18
                chainId: 100
                name: Minerva Wallet SuperToken
                coinKey: MIVA
                priceUSD: '0.04547537276751318'
                logoURI: ''
              toToken:
                address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                symbol: MIVA
                decimals: 18
                chainId: 137
                name: Minerva Wallet SuperToken
                coinKey: MIVA
                priceUSD: '0'
                logoURI: ''
              fromAmount: '1000000000000000000'
              slippage: 0.003
            estimate:
              fromAmount: '1000000000000000000'
              toAmount: '999500000000000000'
              toAmountMin: '999500000000000000'
              approvalAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
              feeCosts:
                - name: Gas Fee
                  description: >-
                    Covers gas expense for sending funds to user on receiving
                    chain.
                  percentage: '0'
                  token:
                    address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                    symbol: MIVA
                    decimals: 18
                    chainId: 100
                    name: Minerva Wallet SuperToken
                    coinKey: MIVA
                    priceUSD: '0.04547537276751318'
                    logoURI: ''
                  amount: '0'
                  amountUSD: '0.00'
                  included: true
                - name: Relay Fee
                  description: >-
                    Covers gas expense for claiming user funds on receiving
                    chain.
                  percentage: '0'
                  token:
                    address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                    symbol: MIVA
                    decimals: 18
                    chainId: 100
                    name: Minerva Wallet SuperToken
                    coinKey: MIVA
                    priceUSD: '0.04547537276751318'
                    logoURI: ''
                  amount: '0'
                  amountUSD: '0.00'
                  included: true
                - name: Router Fee
                  description: Router service fee.
                  percentage: '0.0005'
                  token:
                    address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                    symbol: MIVA
                    decimals: 18
                    chainId: 100
                    name: Minerva Wallet SuperToken
                    coinKey: MIVA
                    priceUSD: '0.04547537276751318'
                    logoURI: ''
                  amount: '500000000000000'
                  amountUSD: '22737686383756.59'
                  included: true
              gasCosts:
                - type: SEND
                  price: '1.26'
                  estimate: '140000'
                  limit: '175000'
                  amount: '176400'
                  amountUSD: '0.00'
                  token:
                    address: '0x0000000000000000000000000000000000000000'
                    symbol: xDai
                    decimals: 18
                    chainId: 100
                    name: xDai
                    coinKey: xDai
                    priceUSD: '1'
                    logoURI: >-
                      https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
              data:
                bid:
                  user: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                  router: '0xeE2Ef40F688607CB23618d9312d62392786d13EB'
                  initiator: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                  sendingChainId: 100
                  sendingAssetId: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                  amount: '1000000000000000000'
                  receivingChainId: 137
                  receivingAssetId: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                  amountReceived: '999500000000000000'
                  receivingAddress: '0x10fBFF9b9450D3A2d9d1612d6dE3726fACD8809E'
                  transactionId: >-
                    0x48f0a2f93b0d0a9dab992d07c46bca38516c945101e8f8e08ca42af05b9e6aa9
                  expiry: 1643364189
                  callDataHash: >-
                    0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470
                  callTo: '0x0000000000000000000000000000000000000000'
                  encryptedCallData: 0x
                  sendingChainTxManagerAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
                  receivingChainTxManagerAddress: '0x6090De2EC76eb1Dc3B5d632734415c93c44Fd113'
                  bidExpiry: 1643105290
                gasFeeInReceivingToken: '0'
                totalFee: '500000000000000'
                metaTxRelayerFee: '0'
                routerFee: '500000000000000'
            integrator: fee-demo
    UnavailableRoutes:
      type: object
      properties:
        filteredOut:
          description: >-
            An object containing information about routes that were
            intentionally filtered out.
          type: array
          items:
            properties:
              overallPath:
                description: The complete representation of the attempted route.
                type: string
                example: 100:USDC-hop-137:USDC-137:USDC~137:SUSHI
              reason:
                description: Out best attempt at describing the failure.
                type: string
        failed:
          description: An object containing information about failed routes.
          type: array
          items:
            properties:
              overallPath:
                description: The complete representation of the attempted route.
                type: string
                example: 100:USDC-hop-137:USDC-137:USDC~137:SUSHI
              subpaths:
                description: An object with all subpaths that generated one or more errors
                type: object
                additionalProperties:
                  $ref: '#/components/schemas/ToolError'
    Token:
      title: Root Type for Token
      description: Representation of a Token
      required:
        - address
        - chainId
        - decimals
        - name
        - symbol
      type: object
      properties:
        address:
          description: Address of the token
          type: string
        decimals:
          format: number
          description: Number of decimals the token uses
          type: number
        symbol:
          description: Symbol of the token
          type: string
        chainId:
          format: number
          description: Id of the token's chain
          type: number
        coinKey:
          description: Identifier for the token
          type: string
        name:
          description: Name of the token
          type: string
        logoURI:
          description: Logo of the token
          type: string
        priceUSD:
          description: Token price in USD
          type: string
      example:
        address: '0x8f3cf7ad23cd3cadbd9735aff958023239c6a063'
        symbol: DAI
        decimals: 18
        chainId: 137
        name: (PoS) Dai Stablecoin
        coinKey: DAI
        priceUSD: '1'
        logoURI: >-
          https://static.debank.com/image/matic_token/logo_url/0x8f3cf7ad23cd3cadbd9735aff958023239c6a063/549c4205dbb199f1b8b03af783f35e71.png
    Step:
      title: Root Type for Step
      description: Object that represents one step of a `Route`
      required:
        - id
        - action
        - tool
        - type
      type: object
      properties:
        id:
          description: Unique identifier of the step
          type: string
        type:
          description: >-
            The type of the step. `swap` executes a DEX swap on a single chain,
            `cross` bridges assets between chains, `lifi` runs LiFi's internal
            multi-action logic, and `protocol` represents protocol-level actions
            such as fee collection or vault interactions executed inside LiFi
            managed contracts.
          enum:
            - swap
            - cross
            - lifi
            - protocol
          type: string
        tool:
          description: The tool used for this step. E.g. `relay`
          type: string
        toolDetails:
          description: The details of the tool used for this step. E.g. `relay`
          type: object
          properties:
            key:
              description: The tool key
              type: string
            name:
              description: The tool name
              type: string
            logoURI:
              description: The tool logo URL
              type: string
        action:
          $ref: '#/components/schemas/Action'
          description: The action of the step
        estimate:
          $ref: '#/components/schemas/Estimate'
          description: The estimation for the step
        integrator:
          description: >-
            A string containing tracking information about the integrator of the
            API
          type: string
        includedSteps:
          type: array
          items:
            $ref: '#/components/schemas/IncludedStep'
        referrer:
          description: >-
            A string containing tracking information about the referrer of the
            integrator
          type: string
        execution:
          description: An objection containing status information about the execution
        transactionRequest:
          description: >-
            An ether.js TransactionRequest that can be triggered using a wallet
            provider.
            (https://docs.ethers.io/v5/api/providers/types/#providers-TransactionRequest)
      example:
        id: '0x48f0a2f93b0d0a9dab992d07c46bca38516c945101e8f8e08ca42af05b9e6aa9'
        type: cross
        tool: relay
        action:
          fromChainId: 100
          toChainId: 137
          fromToken:
            address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
            symbol: MIVA
            decimals: 18
            chainId: 100
            name: Minerva Wallet SuperToken
            coinKey: MIVA
            priceUSD: '0.04547537276751318'
            logoURI: ''
          toToken:
            address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
            symbol: MIVA
            decimals: 18
            chainId: 137
            name: Minerva Wallet SuperToken
            coinKey: MIVA
            priceUSD: '0'
            logoURI: ''
          fromAmount: '1000000000000000000'
          slippage: 0.003
        estimate:
          fromAmount: '1000000000000000000'
          toAmount: '999500000000000000'
          toAmountMin: '999500000000000000'
          approvalAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
          feeCosts:
            - name: Gas Fee
              description: Covers gas expense for sending funds to user on receiving chain.
              percentage: '0'
              token:
                address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                symbol: MIVA
                decimals: 18
                chainId: 100
                name: Minerva Wallet SuperToken
                coinKey: MIVA
                priceUSD: '0.04547537276751318'
                logoURI: ''
              amount: '0'
              amountUSD: '0.00'
              included: true
            - name: Relay Fee
              description: Covers gas expense for claiming user funds on receiving chain.
              percentage: '0'
              token:
                address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                symbol: MIVA
                decimals: 18
                chainId: 100
                name: Minerva Wallet SuperToken
                coinKey: MIVA
                priceUSD: '0.04547537276751318'
                logoURI: ''
              amount: '0'
              amountUSD: '0.00'
              included: true
            - name: Router Fee
              description: Router service fee.
              percentage: '0.0005'
              token:
                address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                symbol: MIVA
                decimals: 18
                chainId: 100
                name: Minerva Wallet SuperToken
                coinKey: MIVA
                priceUSD: '0.04547537276751318'
                logoURI: ''
              amount: '500000000000000'
              amountUSD: '22737686383756.59'
              included: true
          gasCosts:
            - type: SEND
              price: '1.26'
              estimate: '140000'
              limit: '175000'
              amount: '176400'
              amountUSD: '0.00'
              token:
                address: '0x0000000000000000000000000000000000000000'
                symbol: xDai
                decimals: 18
                chainId: 100
                name: xDai
                coinKey: xDai
                priceUSD: '1'
                logoURI: >-
                  https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
          data:
            bid:
              user: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
              router: '0xeE2Ef40F688607CB23618d9312d62392786d13EB'
              initiator: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
              sendingChainId: 100
              sendingAssetId: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
              amount: '1000000000000000000'
              receivingChainId: 137
              receivingAssetId: '0xc0b2983a17573660053beeed6fdb1053107cf387'
              amountReceived: '999500000000000000'
              receivingAddress: '0x10fBFF9b9450D3A2d9d1612d6dE3726fACD8809E'
              transactionId: >-
                0x48f0a2f93b0d0a9dab992d07c46bca38516c945101e8f8e08ca42af05b9e6aa9
              expiry: 1643364189
              callDataHash: >-
                0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470
              callTo: '0x0000000000000000000000000000000000000000'
              encryptedCallData: 0x
              sendingChainTxManagerAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
              receivingChainTxManagerAddress: '0x6090De2EC76eb1Dc3B5d632734415c93c44Fd113'
              bidExpiry: 1643105290
            gasFeeInReceivingToken: '0'
            totalFee: '500000000000000'
            metaTxRelayerFee: '0'
            routerFee: '500000000000000'
        integrator: fee-demo
    ToolError:
      title: An error returned by a tool (Exchange or Bridge)
      description: Describes why a certain operation (like a quote request) failed.
      type: object
      properties:
        errorType:
          description: The type of error that occurred.
          enum:
            - NO_QUOTE
          type: string
        code:
          description: The error code.
          enum:
            - NO_POSSIBLE_ROUTE
            - INSUFFICIENT_LIQUIDITY
            - TOOL_TIMEOUT
            - UNKNOWN_ERROR
            - RPC_ERROR
            - AMOUNT_TOO_LOW
            - AMOUNT_TOO_HIGH
            - FEES_HIGHER_THAN_AMOUNT
            - DIFFERENT_RECIPIENT_NOT_SUPPORTED
            - TOOL_SPECIFIC_ERROR
            - CANNOT_GUARANTEE_MIN_AMOUNT
            - RATE_LIMIT_EXCEEDED
          type: string
        action:
          $ref: '#/components/schemas/Action'
        tool:
          description: The tool that emitted the error.
          type: string
        message:
          description: A human-readable message describing the error.
          type: string
    Action:
      title: Root Type for Action
      description: Object describing what happens in a `Step`
      required:
        - fromToken
        - fromAmount
        - fromChainId
        - toChainId
        - toToken
      type: object
      properties:
        fromChainId:
          format: number
          description: The id of the chain where the transfer should start
          type: number
        fromAmount:
          description: The amount that should be transferred including all decimals
          type: string
        fromToken:
          $ref: '#/components/schemas/Token'
          description: The sending token
        toChainId:
          format: number
          description: The id of the chain where the transfer should end
          type: number
        toToken:
          $ref: '#/components/schemas/Token'
          description: The token that should be transferred to
        slippage:
          format: double
          description: The maximum allowed slippage
          type: number
        fromAddress:
          description: The sending wallet address
          type: string
        toAddress:
          description: The receiving wallet address
          type: string
      example:
        fromChainId: 100
        fromAmount: '1000000000000000000'
        fromToken:
          address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
          symbol: MIVA
          decimals: 18
          chainId: 100
          name: Minerva Wallet SuperToken
          coinKey: MIVA
          priceUSD: '0.0455272371751059'
          logoURI: ''
        toChainId: 137
        toToken:
          address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
          symbol: MIVA
          decimals: 18
          chainId: 137
          name: Minerva Wallet SuperToken
          coinKey: MIVA
          priceUSD: '0'
          logoURI: ''
        slippage: 0.003
    Estimate:
      title: Root Type for Estimate
      description: An estimate for the current transfer
      required:
        - fromAmount
        - approvalAddress
        - toAmount
        - toAmountMin
        - tool
        - executionDuration
      type: object
      properties:
        tool:
          description: The tools that is being used for this step
          type: string
        fromAmount:
          description: The amount that should be transferred including all decimals
          type: string
        fromAmountUSD:
          description: The amount that should be transferred in USD equivalent
          type: string
        toAmount:
          description: >-
            The estimated resulting amount of the `toToken` including all
            decimals
          type: string
        toAmountMin:
          description: The minimal outcome of the transfer including all decimals
          type: string
        toAmountUSD:
          description: The estimated resulting amount of the `toToken` in USD equivalent
          type: string
        approvalAddress:
          description: The contract address for the approval
          type: string
        feeCosts:
          description: Fees included in the transfer
          type: array
          items:
            $ref: '#/components/schemas/FeeCost'
        gasCosts:
          description: Gas costs included in the transfer
          type: array
          items:
            $ref: '#/components/schemas/GasCost'
        executionDuration:
          description: The time needed to complete the following step
          type: number
        data:
          description: Arbitrary data that depends on the the used tool
          type: object
          properties:
            bid:
              type: object
              properties:
                user:
                  type: string
                router:
                  type: string
                initiator:
                  type: string
                sendingChainId:
                  format: number
                  type: number
                sendingAssetId:
                  type: string
                amount:
                  type: string
                receivingChainId:
                  format: number
                  type: number
                receivingAssetId:
                  type: string
                amountReceived:
                  type: string
                receivingAddress:
                  type: string
                transactionId:
                  type: string
                expiry:
                  format: number
                  type: number
                callDataHash:
                  type: string
                callTo:
                  type: string
                encryptedCallData:
                  type: string
                sendingChainTxManagerAddress:
                  type: string
                receivingChainTxManagerAddress:
                  type: string
                bidExpiry:
                  format: number
                  type: number
            bidSignature:
              type: string
            gasFeeInReceivingToken:
              type: string
            totalFee:
              type: string
            metaTxRelayerFee:
              type: string
            routerFee:
              type: string
      example:
        fromAmount: '1000000000000000000'
        toAmount: '999500000000000000'
        toAmountMin: '999500000000000000'
        tool: allbridge
        executionDuration: 60
        approvalAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
        feeCosts:
          - name: Gas Fee
            description: Covers gas expense for sending funds to user on receiving chain.
            percentage: '0'
            token:
              address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
              symbol: MIVA
              decimals: 18
              chainId: 100
              name: Minerva Wallet SuperToken
              coinKey: MIVA
              priceUSD: '0.0455272371751059'
              logoURI: ''
            amount: '0'
            amountUSD: '0.00'
            included: true
          - name: Relay Fee
            description: Covers gas expense for claiming user funds on receiving chain.
            percentage: '0'
            token:
              address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
              symbol: MIVA
              decimals: 18
              chainId: 100
              name: Minerva Wallet SuperToken
              coinKey: MIVA
              priceUSD: '0.0455272371751059'
              logoURI: ''
            amount: '0'
            amountUSD: '0.00'
            included: true
          - name: Router Fee
            description: Router service fee.
            percentage: '0.0005'
            token:
              address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
              symbol: MIVA
              decimals: 18
              chainId: 100
              name: Minerva Wallet SuperToken
              coinKey: MIVA
              priceUSD: '0.0455272371751059'
              logoURI: ''
            amount: '500000000000000'
            amountUSD: '22763618587552.95'
            included: true
        gasCosts:
          - type: SEND
            price: '1.22'
            estimate: '140000'
            limit: '175000'
            amount: '170800'
            amountUSD: '0.00'
            token:
              address: '0x0000000000000000000000000000000000000000'
              symbol: xDai
              decimals: 18
              chainId: 100
              name: xDai
              coinKey: xDai
              priceUSD: '1'
              logoURI: >-
                https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
        data:
          bid:
            user: '0x10fBFF9b9450D3A2d9d1612d6dE3726fACD8809E'
            router: '0xeE2Ef40F688607CB23618d9312d62392786d13EB'
            initiator: '0x10fBFF9b9450D3A2d9d1612d6dE3726fACD8809E'
            sendingChainId: 100
            sendingAssetId: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
            amount: '1000000000000000000'
            receivingChainId: 137
            receivingAssetId: '0xc0b2983a17573660053beeed6fdb1053107cf387'
            amountReceived: '999500000000000000'
            receivingAddress: '0x10fBFF9b9450D3A2d9d1612d6dE3726fACD8809E'
            transactionId: '0x9f54c1764e19367c44706f4a6253941b81e9ec524af5590091aa8ae67e7644ed'
            expiry: 1643369368
            callDataHash: '0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470'
            callTo: '0x0000000000000000000000000000000000000000'
            encryptedCallData: 0x
            sendingChainTxManagerAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
            receivingChainTxManagerAddress: '0x6090De2EC76eb1Dc3B5d632734415c93c44Fd113'
            bidExpiry: 1643110469
          gasFeeInReceivingToken: '0'
          totalFee: '500000000000000'
          metaTxRelayerFee: '0'
          routerFee: '500000000000000'
    IncludedStep:
      title: Root Type for Internal Step
      description: Object that represents one step of an `IncludedSteps` array in `Route`
      required:
        - id
        - action
        - estimate
        - tool
        - type
        - toolDetails
      type: object
      properties:
        id:
          description: Unique identifier of the step
          type: string
        type:
          description: >-
            The type of the step. `swap` executes a DEX swap on a single chain,
            `cross` bridges assets between chains, `lifi` runs LiFi's internal
            multi-action logic, and `protocol` represents protocol-level actions
            such as fee collection or vault interactions executed inside LiFi
            managed contracts.
          enum:
            - swap
            - cross
            - lifi
            - protocol
          type: string
        tool:
          description: The tool used for this step. E.g. `allbridge`
          type: string
        toolDetails:
          description: The details of the tool used for this step. E.g. `allbridge`
          type: object
          properties:
            key:
              description: The tool key
              type: string
            name:
              description: The tool name
              type: string
            logoURI:
              description: The tool logo URL
              type: string
        action:
          $ref: '#/components/schemas/Action'
        estimate:
          $ref: '#/components/schemas/Estimate'
    FeeCost:
      title: Root Type for FeeCost
      description: Fees included in the transfer
      required:
        - token
        - percentage
        - name
        - amountUSD
        - included
      type: object
      properties:
        name:
          description: Name of the fee
          type: string
        description:
          description: Description of the fee costs
          type: string
        percentage:
          description: Percentage of how much fees are taken
          type: string
        token:
          $ref: '#/components/schemas/Token'
          description: The `Token` in which the fees are taken
        amount:
          description: The amount of fees
          type: string
        amountUSD:
          description: The amount of fees in USD
          type: string
        included:
          description: Whether fee is included into transfer's `fromAmount`
          type: boolean
      example:
        name: Gas Fee
        description: Covers gas expense for sending funds to user on receiving chain.
        percentage: '0'
        token:
          address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
          symbol: MIVA
          decimals: 18
          chainId: 100
          name: Minerva Wallet SuperToken
          coinKey: MIVA
          priceUSD: '0.0455272371751059'
          logoURI: ''
        amount: '0'
        amountUSD: '0.00'
    GasCost:
      title: Root Type for GasCost
      description: Gas costs included in the transfer
      required:
        - token
        - type
        - amount
      type: object
      properties:
        type:
          description: Can be one of `SUM`, `APPROVE` or `SEND`
          type: string
        price:
          description: Suggested current standard price for the chain
          type: string
        estimate:
          description: Estimation how much gas will be needed
          type: string
        limit:
          description: Suggested gas limit
          type: string
        amount:
          description: Amount of the gas cost
          type: string
        amountUSD:
          description: Amount of the gas cost in USD
          type: string
        token:
          $ref: '#/components/schemas/Token'
          description: The used gas token
      example:
        type: SEND
        price: '1.22'
        estimate: '140000'
        limit: '175000'
        amount: '170800'
        amountUSD: '0.00'
        token:
          address: '0x0000000000000000000000000000000000000000'
          symbol: xDai
          decimals: 18
          chainId: 100
          name: xDai
          coinKey: xDai
          priceUSD: '1'
          logoURI: >-
            https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
  responses:
    RoutesResponse:
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/RoutesResponse'
          examples:
            RoutesResponseExample:
              value:
                routes:
                  - id: >-
                      0x1e21fad9c26fff48b67ae2925f878e43bf81211da8b1cd9b7faa8bfd8d7ea9d9
                    fromChainId: 100
                    fromAmountUSD: '0.05'
                    fromAmount: '1000000000000000000'
                    fromToken:
                      address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                      symbol: MIVA
                      decimals: 18
                      chainId: 100
                      name: Minerva Wallet SuperToken
                      coinKey: MIVA
                      priceUSD: '0.04547537276751318'
                      logoURI: ''
                    toChainId: 137
                    toAmountUSD: '0.00'
                    toAmount: '999500000000000000'
                    toAmountMin: '999500000000000000'
                    toToken:
                      address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                      symbol: MIVA
                      decimals: 18
                      chainId: 137
                      name: Minerva Wallet SuperToken
                      coinKey: MIVA
                      priceUSD: '0'
                      logoURI: ''
                    gasCostUSD: '0.00'
                    steps:
                      - id: >-
                          0x48f0a2f93b0d0a9dab992d07c46bca38516c945101e8f8e08ca42af05b9e6aa9
                        type: cross
                        tool: relay
                        action:
                          fromChainId: 100
                          toChainId: 137
                          fromToken:
                            address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                            symbol: MIVA
                            decimals: 18
                            chainId: 100
                            name: Minerva Wallet SuperToken
                            coinKey: MIVA
                            priceUSD: '0.04547537276751318'
                            logoURI: ''
                          toToken:
                            address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                            symbol: MIVA
                            decimals: 18
                            chainId: 137
                            name: Minerva Wallet SuperToken
                            coinKey: MIVA
                            priceUSD: '0'
                            logoURI: ''
                          fromAmount: '1000000000000000000'
                          slippage: 0.003
                        estimate:
                          fromAmount: '1000000000000000000'
                          toAmount: '999500000000000000'
                          toAmountMin: '999500000000000000'
                          approvalAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
                          feeCosts:
                            - name: Gas Fee
                              description: >-
                                Covers gas expense for sending funds to user on
                                receiving chain.
                              percentage: '0'
                              token:
                                address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                                symbol: MIVA
                                decimals: 18
                                chainId: 100
                                name: Minerva Wallet SuperToken
                                coinKey: MIVA
                                priceUSD: '0.04547537276751318'
                                logoURI: ''
                              amount: '0'
                              amountUSD: '0.00'
                              included: true
                            - name: Relay Fee
                              description: >-
                                Covers gas expense for claiming user funds on
                                receiving chain.
                              percentage: '0'
                              token:
                                address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                                symbol: MIVA
                                decimals: 18
                                chainId: 100
                                name: Minerva Wallet SuperToken
                                coinKey: MIVA
                                priceUSD: '0.04547537276751318'
                                logoURI: ''
                              amount: '0'
                              amountUSD: '0.00'
                              included: true
                            - name: Router Fee
                              description: Router service fee.
                              percentage: '0.0005'
                              token:
                                address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                                symbol: MIVA
                                decimals: 18
                                chainId: 100
                                name: Minerva Wallet SuperToken
                                coinKey: MIVA
                                priceUSD: '0.04547537276751318'
                                logoURI: ''
                              amount: '500000000000000'
                              amountUSD: '22737686383756.59'
                              included: true
                          gasCosts:
                            - type: SEND
                              price: '1.26'
                              estimate: '140000'
                              limit: '175000'
                              amount: '176400'
                              amountUSD: '0.00'
                              token:
                                address: '0x0000000000000000000000000000000000000000'
                                symbol: xDai
                                decimals: 18
                                chainId: 100
                                name: xDai
                                coinKey: xDai
                                priceUSD: '1'
                                logoURI: >-
                                  https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
                          data:
                            bid:
                              user: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                              router: '0xeE2Ef40F688607CB23618d9312d62392786d13EB'
                              initiator: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                              sendingChainId: 100
                              sendingAssetId: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                              amount: '1000000000000000000'
                              receivingChainId: 137
                              receivingAssetId: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                              amountReceived: '999500000000000000'
                              receivingAddress: '0x10fBFF9b9450D3A2d9d1612d6dE3726fACD8809E'
                              transactionId: >-
                                0x48f0a2f93b0d0a9dab992d07c46bca38516c945101e8f8e08ca42af05b9e6aa9
                              expiry: 1643364189
                              callDataHash: >-
                                0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470
                              callTo: '0x0000000000000000000000000000000000000000'
                              encryptedCallData: 0x
                              sendingChainTxManagerAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
                              receivingChainTxManagerAddress: '0x6090De2EC76eb1Dc3B5d632734415c93c44Fd113'
                              bidExpiry: 1643105290
                            gasFeeInReceivingToken: '0'
                            totalFee: '500000000000000'
                            metaTxRelayerFee: '0'
                            routerFee: '500000000000000'
                        integrator: fee-demo
                  - id: >-
                      0xb785f52e68f8a6fb147d5e392e06f122c1a418be84bdc28de0f311b91fa5e57e
                    fromChainId: 100
                    fromAmountUSD: '0.05'
                    fromAmount: '1000000000000000000'
                    fromToken:
                      address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                      symbol: MIVA
                      decimals: 18
                      chainId: 100
                      name: Minerva Wallet SuperToken
                      coinKey: MIVA
                      priceUSD: '0.04547537276751318'
                      logoURI: ''
                    toChainId: 137
                    toAmountUSD: '0.00'
                    toAmount: '941511949935063841'
                    toAmountMin: '913266591437011926'
                    toToken:
                      address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                      symbol: MIVA
                      decimals: 18
                      chainId: 137
                      name: Minerva Wallet SuperToken
                      coinKey: MIVA
                      priceUSD: '0'
                      logoURI: ''
                    gasCostUSD: '0.10'
                    steps:
                      - id: ea5abad4-2e2a-476f-981d-797816e5cc77
                        type: swap
                        tool: 1inch
                        action:
                          fromChainId: 100
                          toChainId: 100
                          fromToken:
                            address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                            symbol: MIVA
                            decimals: 18
                            chainId: 100
                            name: Minerva Wallet SuperToken
                            coinKey: MIVA
                            priceUSD: '0.04547537276751318'
                            logoURI: ''
                          toToken:
                            name: Own a fraction
                            symbol: FRACTION
                            coinKey: FRACTION
                            decimals: 18
                            chainId: 100
                            logoURI: >-
                              https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                            address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                          fromAmount: '1000000000000000000'
                          slippage: 0.003
                        estimate:
                          fromAmount: '1000000000000000000'
                          toAmount: '809146346742'
                          toAmountMin: '784871956340'
                          approvalAddress: '0x1111111254fb6c44bac0bed2854e76f90643097d'
                          feeCosts: []
                          gasCosts:
                            - type: SEND
                              price: '1.26'
                              estimate: '252364'
                              limit: '315455'
                              amount: '317979'
                              amountUSD: '0.00'
                              token:
                                address: '0x0000000000000000000000000000000000000000'
                                symbol: xDai
                                decimals: 18
                                chainId: 100
                                name: xDai
                                coinKey: xDai
                                priceUSD: '1'
                                logoURI: >-
                                  https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
                          data:
                            fromToken:
                              name: Minerva Wallet SuperToken
                              address: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                              symbol: MIVA
                              decimals: 18
                              logoURI: https://minerva.digital/i/MIVA-Token_200x200.png
                            toToken:
                              address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                              decimals: 18
                              symbol: FRACTION
                              name: Own a fraction
                              logoURI: https://etherscan.io/images/main/empty-token.png
                              isCustom: true
                            toTokenAmount: '809146346742'
                            fromTokenAmount: '1000000000000000000'
                            protocols:
                              - - - name: GNOSIS_HONEYSWAP
                                    part: 100
                                    fromTokenAddress: '0x63e62989d9eb2d37dfdb1f93a22f063635b07d51'
                                    toTokenAddress: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                            estimatedGas: 252364
                        integrator: fee-demo
                      - id: >-
                          0x85e93238e8f2f83dd5840eb748c7b9099d69e1ea227a13e7a2e949cf6a32ab7d
                        type: cross
                        tool: relay
                        action:
                          fromChainId: 100
                          toChainId: 137
                          fromToken:
                            name: Own a fraction
                            symbol: FRACTION
                            coinKey: FRACTION
                            decimals: 18
                            chainId: 100
                            logoURI: >-
                              https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                            address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                          toToken:
                            name: Own a fraction
                            symbol: FRACTION
                            coinKey: FRACTION
                            decimals: 18
                            chainId: 137
                            logoURI: >-
                              https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                            address: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                          fromAmount: '784871956340'
                          slippage: 0.003
                        estimate:
                          fromAmount: '784871956340'
                          toAmount: '784479520361'
                          toAmountMin: '784479520361'
                          approvalAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
                          feeCosts:
                            - name: Gas Fee
                              description: >-
                                Covers gas expense for sending funds to user on
                                receiving chain.
                              percentage: '0'
                              token:
                                name: Own a fraction
                                symbol: FRACTION
                                coinKey: FRACTION
                                decimals: 18
                                chainId: 100
                                logoURI: >-
                                  https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                                address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                              amount: '0'
                              amountUSD: '0.00'
                              included: true
                            - name: Relay Fee
                              description: >-
                                Covers gas expense for claiming user funds on
                                receiving chain.
                              percentage: '0'
                              token:
                                name: Own a fraction
                                symbol: FRACTION
                                coinKey: FRACTION
                                decimals: 18
                                chainId: 100
                                logoURI: >-
                                  https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                                address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                              amount: '0'
                              amountUSD: '0.00'
                              included: true
                            - name: Router Fee
                              description: Router service fee.
                              percentage: '0.00050000000105749733'
                              token:
                                name: Own a fraction
                                symbol: FRACTION
                                coinKey: FRACTION
                                decimals: 18
                                chainId: 100
                                logoURI: >-
                                  https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                                address: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                              amount: '392435979'
                              amountUSD: '0.00'
                              included: true
                          gasCosts:
                            - type: SEND
                              price: '1.26'
                              estimate: '140000'
                              limit: '175000'
                              amount: '176400'
                              amountUSD: '0.00'
                              token:
                                address: '0x0000000000000000000000000000000000000000'
                                symbol: xDai
                                decimals: 18
                                chainId: 100
                                name: xDai
                                coinKey: xDai
                                priceUSD: '1'
                                logoURI: >-
                                  https://static.debank.com/image/xdai_token/logo_url/xdai/1207e67652b691ef3bfe04f89f4b5362.png
                          data:
                            bid:
                              user: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                              router: '0xeE2Ef40F688607CB23618d9312d62392786d13EB'
                              initiator: '0x53F68B2186E4a4aB4dD976eD32de68db45BA360b'
                              sendingChainId: 100
                              sendingAssetId: '0x2bf2ba13735160624a0feae98f6ac8f70885ea61'
                              amount: '784871956340'
                              receivingChainId: 137
                              receivingAssetId: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                              amountReceived: '784479520361'
                              receivingAddress: '0x10fBFF9b9450D3A2d9d1612d6dE3726fACD8809E'
                              transactionId: >-
                                0x85e93238e8f2f83dd5840eb748c7b9099d69e1ea227a13e7a2e949cf6a32ab7d
                              expiry: 1643364189
                              callDataHash: >-
                                0xc5d2460186f7233c927e7db2dcc703c0e500b653ca82273b7bfad8045d85a470
                              callTo: '0x0000000000000000000000000000000000000000'
                              encryptedCallData: 0x
                              sendingChainTxManagerAddress: '0x115909BDcbaB21954bEb4ab65FC2aBEE9866fa93'
                              receivingChainTxManagerAddress: '0x6090De2EC76eb1Dc3B5d632734415c93c44Fd113'
                              bidExpiry: 1643105290
                            gasFeeInReceivingToken: '0'
                            totalFee: '392435979'
                            metaTxRelayerFee: '0'
                            routerFee: '392435979'
                        integrator: fee-demo
                      - id: d8686af1-c131-4566-bf4a-ef8226f9879b
                        type: swap
                        tool: 1inch
                        action:
                          fromChainId: 137
                          toChainId: 137
                          fromToken:
                            name: Own a fraction
                            symbol: FRACTION
                            coinKey: FRACTION
                            decimals: 18
                            chainId: 137
                            logoURI: >-
                              https://assets.coingecko.com/coins/images/15099/large/fraction.png?1619691519
                            address: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                          toToken:
                            address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                            symbol: MIVA
                            decimals: 18
                            chainId: 137
                            name: Minerva Wallet SuperToken
                            coinKey: MIVA
                            priceUSD: '0'
                            logoURI: ''
                          fromAmount: '784479520361'
                          slippage: 0.003
                        estimate:
                          fromAmount: '784479520361'
                          toAmount: '941511949935063841'
                          toAmountMin: '913266591437011926'
                          approvalAddress: '0x1111111254fb6c44bac0bed2854e76f90643097d'
                          feeCosts: []
                          gasCosts:
                            - type: SEND
                              price: '129'
                              estimate: '549386'
                              limit: '686733'
                              amount: '70870794'
                              amountUSD: '0.10'
                              token:
                                address: '0x0000000000000000000000000000000000000000'
                                symbol: MATIC
                                decimals: 18
                                chainId: 137
                                name: MATIC
                                coinKey: MATIC
                                priceUSD: '1.469213'
                                logoURI: >-
                                  https://static.debank.com/image/matic_token/logo_url/matic/e5a8a2860ba5cf740a474dcab796dc63.png
                          data:
                            fromToken:
                              address: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                              decimals: 18
                              symbol: FRACTION
                              name: Own a fraction
                              logoURI: https://etherscan.io/images/main/empty-token.png
                              isCustom: true
                            toToken:
                              address: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                              decimals: 18
                              symbol: MIVA
                              name: Minerva Wallet SuperToken
                              logoURI: https://etherscan.io/images/main/empty-token.png
                              isCustom: true
                            toTokenAmount: '941511949935063841'
                            fromTokenAmount: '784479520361'
                            protocols:
                              - - - name: POLYGON_QUICKSWAP
                                    part: 100
                                    fromTokenAddress: '0xbd80cfa9d93a87d1bb895f810ea348e496611cd4'
                                    toTokenAddress: '0x7ceb23fd6bc0add59e62ac25578270cff1b9f619'
                                - - name: POLYDEX_FINANCE
                                    part: 100
                                    fromTokenAddress: '0x7ceb23fd6bc0add59e62ac25578270cff1b9f619'
                                    toTokenAddress: '0xeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee'
                                - - name: POLYGON_QUICKSWAP
                                    part: 100
                                    fromTokenAddress: '0xeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee'
                                    toTokenAddress: '0xc0b2983a17573660053beeed6fdb1053107cf387'
                            estimatedGas: 549386
                        integrator: fee-demo
                errors:
                  - errorType: NO_QUOTE
                    code: NO_POSSIBLE_ROUTE
                    action:
                      fromChainId: 42161
                      toChainId: 42161
                      fromToken:
                        address: '0xff970a61a04b1ca14834a43f5de4533ebddb5cc8'
                        decimals: 6
                        symbol: USDC
                        coinKey: USDC
                        chainId: 42161
                        name: USDC
                        logoURI: >-
                          http://raw.githubusercontent.com/trustwallet/assets/master/blockchains/ethereum/assets/0xA0b86991c6218b36c1d19D4a2e9Eb0cE3606eB48/logo.png",
                        priceUSD: '1.001'
                      toToken:
                        address: '0xfd086bc7cd5c481dcc9c85ebe478a1c0b69fcbb9'
                        decimals: 6
                        symbol: USDT
                        coinKey: USDT
                        chainId: 42161
                        name: Tether USD
                        logoURI: http://get.celer.app/cbridge-icons/USDT.png"
                      fromAmount: '100000'
                      slippage: 0.003
      description: >-
        The resulting routes that can be used to realize the described transfer
        of tokens
    InvalidRoutesRequest:
      description: Invalid Routes Request
    InvalidRoutesNotFoundRequest:
      description: Requested `to` or `from` token was not found

````